## GAction GAction — An action interface |

## Functions

gboolean | g_action_name_is_valid ()
const gchar * | g_action_get_name ()
const GVariantType * | g_action_get_parameter_type ()
const GVariantType * | g_action_get_state_type ()
GVariant * | g_action_get_state_hint ()
gboolean | g_action_get_enabled ()
GVariant * | g_action_get_state ()
void | g_action_change_state ()
void | g_action_activate ()
gboolean | g_action_parse_detailed_name ()
gchar * | g_action_print_detailed_name ()

## Properties

gboolean | enabled | Read
gchar * | name | Read
GVariantType * | parameter-type | Read
GVariant * | state | Read
GVariantType * | state-type | Read

## Types and Values

| GAction
struct | GActionInterface

## Object Hierarchy

        GInterface
        ╰── GAction

## Prerequisites

GAction requires GObject.

## Known Implementations

GAction is implemented by GPropertyAction and GSimpleAction.

## Includes

    #include <gio/gio.h>

## Description

GAction represents a single named action.

The main interface to an action is that it can be activated with `g_action_activate()`. This results in the 'activate' signal being emitted. An activation has a GVariant parameter (which may be `NULL`). The correct type for the parameter is determined by a static parameter type (which is given at construction time).

An action may optionally have a state, in which case the state may be set with `g_action_change_state()`. This call takes a GVariant. The correct type for the state is determined by a static state type (which is given at construction time).

The state may have a hint associated with it, specifying its valid range.

GAction is merely the interface to the concept of an action, as described above. Various implementations of actions exist, including GSimpleAction.

In all cases, the implementing class is responsible for storing the name of the action, the parameter type, the enabled state, the optional state type and the state and emitting the appropriate signals when these change. The implementor is responsible for filtering calls to `g_action_activate()` and `g_action_change_state()` for type safety and for the state being enabled.

Probably the only useful thing to do with a GAction is to put it inside of a GSimpleActionGroup.

## Functions

### g_action_name_is_valid ()

    gboolean
    g_action_name_is_valid (const gchar *action_name);

Checks if `action_name` is valid.

`action_name` is valid if it consists only of alphanumeric characters, plus '-' and '.'. The empty string is not a valid action name.

It is an error to call this function with a non-utf8 `action_name` . `action_name` must not be `NULL`.

#### Parameters

action_name | a potential action name |

#### Returns

`TRUE` if `action_name` is valid

Since: 2.38

### g_action_get_name ()

    const gchar *
    g_action_get_name (GAction *action);

Queries the name of `action` .

#### Parameters

action | a GAction |

#### Returns

the name of the action

Since: 2.28

### g_action_get_parameter_type ()

    const GVariantType *
    g_action_get_parameter_type (GAction *action);

Queries the type of the parameter that must be given when activating `action` .

When activating the action using `g_action_activate()`, the GVariant given to that function must be of the type returned by this function.

In the case that this function returns `NULL`, you must not give any GVariant, but `NULL` instead.

#### Parameters

action | a GAction |

#### Returns

the parameter type.

[nullable]

Since: 2.28

### g_action_get_state_type ()

    const GVariantType *
    g_action_get_state_type (GAction *action);

Queries the type of the state of `action` .

If the action is stateful (e.g. created with `g_simple_action_new_stateful()`) then this function returns the GVariantType of the state. This is the type of the initial value given as the state. All calls to `g_action_change_state()` must give a GVariant of this type and `g_action_get_state()` will return a GVariant of the same type.

If the action is not stateful (e.g. created with `g_simple_action_new()`) then this function will return `NULL`. In that case, `g_action_get_state()` will return `NULL` and you must not call `g_action_change_state()`.

#### Parameters

action | a GAction |

#### Returns

the state type, if the action is stateful.

[nullable]

Since: 2.28

### g_action_get_state_hint ()

    GVariant *
    g_action_get_state_hint (GAction *action);

Requests a hint about the valid range of values for the state of `action` .

If `NULL` is returned it either means that the action is not stateful or that there is no hint about the valid range of values for the state of the action.

If a GVariant array is returned then each item in the array is a possible value for the state. If a GVariant pair (ie: two-tuple) is returned then the tuple specifies the inclusive lower and upper bound of valid values for the state.

In any case, the information is merely a hint. It may be possible to have a state value outside of the hinted range and setting a value within the range may fail.

The return value (if non-`NULL`) should be freed with `g_variant_unref()` when it is no longer required.

#### Parameters

action | a GAction |

#### Returns

the state range hint.

[nullable][transfer full]

Since: 2.28

### g_action_get_enabled ()

    gboolean
    g_action_get_enabled (GAction *action);

Checks if `action` is currently enabled.

An action must be enabled in order to be activated or in order to have its state changed from outside callers.

#### Parameters

action | a GAction |

#### Returns

whether the action is enabled

Since: 2.28

### g_action_get_state ()

    GVariant *
    g_action_get_state (GAction *action);

Queries the current state of `action` .

If the action is not stateful then `NULL` will be returned. If the action is stateful then the type of the return value is the type given by `g_action_get_state_type()`.

The return value (if non-`NULL`) should be freed with `g_variant_unref()` when it is no longer required.

#### Parameters

action | a GAction |

#### Returns

the current state of the action.

[transfer full]

Since: 2.28

### g_action_change_state ()

    void
    g_action_change_state (GAction *action,
                           GVariant *value);

Request for the state of `action` to be changed to `value` .

The action must be stateful and `value` must be of the correct type. See `g_action_get_state_type()`.

This call merely requests a change. The action may refuse to change its state or may change its state to something other than `value` . See `g_action_get_state_hint()`.

If the `value` GVariant is floating, it is consumed.

#### Parameters

action | a GAction |
value | the new state |

Since: 2.30

### g_action_activate ()

    void
    g_action_activate (GAction *action,
                       GVariant *parameter);

Activates the action.

`parameter` must be the correct type of parameter for the action (ie: the parameter type given at construction time). If the parameter type was `NULL` then `parameter` must also be `NULL`.

If the `parameter` GVariant is floating, it is consumed.

#### Parameters

action | a GAction |
parameter | the parameter to the activation. | [nullable]

Since: 2.28

### g_action_parse_detailed_name ()

    gboolean
    g_action_parse_detailed_name (const gchar *detailed_name,
                                  gchar **action_name,
                                  GVariant **target_value,
                                  GError **error);

Parses a detailed action name into its separate name and target components.

Detailed action names can have three formats.

The first format is used to represent an action name with no target value and consists of just an action name containing no whitespace nor the characters ':', '(' or ')'. For example: "app.action".

The second format is used to represent an action with a target value that is a non-empty string consisting only of alphanumerics, plus '-' and '.'. In that case, the action name and target value are separated by a double colon ("::"). For example: "app.action::target".

The third format is used to represent an action with any type of target value, including strings. The target value follows the action name, surrounded in parens. For example: "app.action(42)". The target value is parsed using `g_variant_parse()`. If a tuple-typed value is desired, it must be specified in the same way, resulting in two sets of parens, for example: "app.action((1,2,3))". A string target can be specified this way as well: "app.action('target')". For strings, this third format must be used if * target value is empty or contains characters other than alphanumerics, '-' and '.'.

#### Parameters

detailed_name | a detailed action name |
action_name | the action name. | [out]
target_value | the target value, or `NULL` for no target. | [out]
error | a pointer to a `NULL` GError, or `NULL` |

#### Returns

`TRUE` if successful, else `FALSE` with `error` set

Since: 2.38

### g_action_print_detailed_name ()

    gchar *
    g_action_print_detailed_name (const gchar *action_name,
                                  GVariant *target_value);

Formats a detailed action name from `action_name` and `target_value` .

It is an error to call this function with an invalid action name.

This function is the opposite of `g_action_parse_detailed_name()`. It will produce a string that can be parsed back to the `action_name` and `target_value` by that function.

See that function for the types of strings that will be printed by this function.

#### Parameters

action_name | a valid action name |
target_value | a GVariant target value, or `NULL`. | [nullable]

#### Returns

a detailed format string

Since: 2.38

## Types and Values

### GAction

    typedef struct _GAction GAction;

GAction is an opaque data structure and can only be accessed using the following functions.

### struct GActionInterface

    struct GActionInterface {
      GTypeInterface g_iface;

      /* virtual functions */
      const gchar *        (* get_name)             (GAction  *action);
      const GVariantType * (* get_parameter_type)   (GAction  *action);
      const GVariantType * (* get_state_type)       (GAction  *action);
      GVariant *           (* get_state_hint)       (GAction  *action);

      gboolean             (* get_enabled)          (GAction  *action);
      GVariant *           (* get_state)            (GAction  *action);

      void                 (* change_state)         (GAction  *action,
                                                     GVariant *value);
      void                 (* activate)             (GAction  *action,
                                                     GVariant *parameter);
    };

The virtual function table for GAction.

#### Members

`get_name` () | the virtual function pointer for `g_action_get_name()` |
`get_parameter_type` () | the virtual function pointer for `g_action_get_parameter_type()` |
`get_state_type` () | the virtual function pointer for `g_action_get_state_type()` |
`get_state_hint` () | the virtual function pointer for `g_action_get_state_hint()` |
`get_enabled` () | the virtual function pointer for `g_action_get_enabled()` |
`get_state` () | the virtual function pointer for `g_action_get_state()` |
`change_state` () | the virtual function pointer for `g_action_change_state()` |
`activate` () | the virtual function pointer for `g_action_activate()`. Note that GAction does not have an 'activate' signal but that implementations of it may have one. |

Since: 2.28

## Property Details

### The `“enabled”` property

      “enabled”                  gboolean

If `action` is currently enabled.

If the action is disabled then calls to `g_action_activate()` and `g_action_change_state()` have no effect.

Owner: GAction

Flags: Read

Default value: TRUE

Since: 2.28

### The `“name”` property

      “name”                     gchar *

The name of the action. This is mostly meaningful for identifying the action once it has been added to a GActionGroup. It is immutable.

Owner: GAction

Flags: Read

Default value: NULL

Since: 2.28

### The `“parameter-type”` property

      “parameter-type”           GVariantType *

The type of the parameter that must be given when activating the action. This is immutable, and may be `NULL` if no parameter is needed when activating the action.

Owner: GAction

Flags: Read

Since: 2.28

### The `“state”` property

      “state”                    GVariant *

The state of the action, or `NULL` if the action is stateless.

Owner: GAction

Flags: Read

Allowed values: GVariant<*>

Default value: NULL

Since: 2.28

### The `“state-type”` property

      “state-type”               GVariantType *

The GVariantType of the state that the action has, or `NULL` if the action is stateless. This is immutable.

Owner: GAction

Flags: Read

Since: 2.28